## ansible 2.0.0.2

=== Makefile ===
#!/usr/bin/make
# WARN: gmake syntax
########################################################
# Makefile for Ansible
#
# useful targets:
#   make sdist ---------------- produce a tarball
#   make srpm ----------------- produce a SRPM
#   make rpm  ----------------- produce RPMs
#   make deb-src -------------- produce a DEB source
#   make deb ------------------ produce a DEB
#   make docs ----------------- rebuild the manpages (results are checked in)
#   make tests ---------------- run the tests (see test/README.md for requirements)
#   make pyflakes, make pep8 -- source code checks

########################################################
# variable section

NAME = ansible
OS = $(shell uname -s)

# Manpages are currently built with asciidoc -- would like to move to markdown
# This doesn't evaluate until it's called. The -D argument is the
# directory of the target file ($@), kinda like `dirname`.
MANPAGES := docs/man/man1/ansible.1 docs/man/man1/ansible-playbook.1 docs/man/man1/ansible-pull.1 docs/man/man1/ansible-doc.1 docs/man/man1/ansible-galaxy.1 docs/man/man1/ansible-vault.1
ifneq ($(shell which a2x 2>/dev/null),)
ASCII2MAN = a2x -D $(dir $@) -d manpage -f manpage $<
ASCII2HTMLMAN = a2x -D docs/html/man/ -d manpage -f xhtml
else
ASCII2MAN = @echo "ERROR: AsciiDoc 'a2x' command is not installed but is required to build $(MANPAGES)" && exit 1
endif

PYTHON=python
SITELIB = $(shell $(PYTHON) -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")

# VERSION file provides one place to update the software version
VERSION := $(shell cat VERSION | cut -f1 -d' ')
RELEASE := $(shell cat VERSION | cut -f2 -d' ')

# Get the branch information from git
ifneq ($(shell which git),)
GIT_DATE := $(shell git log -n 1 --format="%ai")
GIT_HASH := $(shell git log -n 1 --format="%h")
GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD | sed 's/[-_.\/]//g')
GITINFO = .$(GIT_HASH).$(GIT_BRANCH)
else
GITINFO = ""
endif

ifeq ($(shell echo $(OS) | egrep -c 'Darwin|FreeBSD|OpenBSD'),1)
DATE := $(shell date -j -r $(shell git log -n 1 --format="%at") +%Y%m%d%H%M)
else
DATE := $(shell date --utc --date="$(GIT_DATE)" +%Y%m%d%H%M)
endif

# DEB build parameters
DEBUILD_BIN ?= debuild
DEBUILD_OPTS = --source-option="-I"
DPUT_BIN ?= dput
DPUT_OPTS ?=
DEB_DATE := $(shell LC_TIME=C date +"%a, %d %b %Y %T %z")
ifeq ($(OFFICIAL),yes)
    DEB_RELEASE = $(RELEASE)ppa
    # Sign OFFICIAL builds using 'DEBSIGN_KEYID'
    # DEBSIGN_KEYID is required when signing
    ifneq ($(DEBSIGN_KEYID),)
        DEBUILD_OPTS += -k$(DEBSIGN_KEYID)
    endif
else
    DEB_RELEASE = 0.git$(DATE)$(GITINFO)
    # Do not sign unofficial builds
    DEBUILD_OPTS += -uc -us
    DPUT_OPTS += -u
endif
DEBUILD = $(DEBUILD_BIN) $(DEBUILD_OPTS)
DEB_PPA ?= ppa
# Choose the desired Ubuntu release: lucid precise saucy trusty
DEB_DIST ?= unstable

# RPM build parameters
RPMSPECDIR= packaging/rpm
RPMSPEC = $(RPMSPECDIR)/ansible.spec
RPMDIST = $(shell rpm --eval '%{?dist}')
RPMRELEASE = $(RELEASE)
ifneq ($(OFFICIAL),yes)
    RPMRELEASE = 0.git$(DATE)$(GITINFO)
endif
RPMNVR = "$(NAME)-$(VERSION)-$(RPMRELEASE)$(RPMDIST)"

# MOCK build parameters
MOCK_BIN ?= mock
MOCK_CFG ?=

NOSETESTS ?= nosetests

NOSETESTS3 ?= nosetests-3.4

########################################################

all: clean python

tests:
	PYTHONPATH=./lib $(NOSETESTS) -d -w test/units -v --with-coverage --cover-package=ansible --cover-branches

tests-py3:
	PYTHONPATH=./lib $(NOSETESTS3) -d -w test/units -v --with-coverage --cover-package=ansible --cover-branches

authors:
	sh hacking/authors.sh

# Regenerate %.1.asciidoc if %.1.asciidoc.in has been modified more
# recently than %.1.asciidoc.
%.1.asciidoc: %.1.asciidoc.in
	sed "s/%VERSION%/$(VERSION)/" $< > $@

# Regenerate %.1 if %.1.asciidoc or VERSION has been modified more
# recently than %.1. (Implicitly runs the %.1.asciidoc recipe)
%.1: %.1.asciidoc VERSION
	$(ASCII2MAN)

loc:
	sloccount lib library bin

pep8:
	@echo "#############################################"
	@echo "# Running PEP8 Compliance Tests"
	@echo "#############################################"
	-pep8 -r --ignore=E501,E221,W291,W391,E302,E251,E203,W293,E231,E303,E201,E225,E261,E241 lib/ bin/
	# -pep8 -r --ignore=E501,E221,W291,W391,E302,E251,E203,W293,E231,E303,E201,E225,E261,E241 --filename "*" library/

pyflakes:
	pyflakes lib/ansible/*.py lib/ansible/*/*.py bin/*

clean:
	@echo "Cleaning up distutils stuff"
	rm -rf build
	rm -rf dist
	rm -rf lib/ansible.egg-info/
	@echo "Cleaning up byte compiled python stuff"
	find . -type f -regex ".*\.py[co]$$" -delete
	@echo "Cleaning up editor backup files"
	find . -type f -not -path ./test/units/inventory_test_data/group_vars/noparse/all.yml~ \( -name "*~" -or -name "#*" \) -delete
	find . -type f \( -name "*.swp" \) -delete
	@echo "Cleaning up manpage stuff"
	find ./docs/man -type f -name "*.xml" -delete
	find ./docs/man -type f -name "*.asciidoc" -delete
	find ./docs/man/man3 -type f -name "*.3" -delete
	@echo "Cleaning up output from test runs"
	rm -rf test/test_data
	@echo "Cleaning up RPM building stuff"
	rm -rf MANIFEST rpm-build
	@echo "Cleaning up Debian building stuff"
	rm -rf debian
	rm -rf deb-build
	rm -rf docs/json
	rm -rf docs/js
	@echo "Cleaning up authors file"
	rm -f AUTHORS.TXT
	find . -type f -name '*.pyc' -delete

python:
	$(PYTHON) setup.py build

install:
	$(PYTHON) setup.py install

sdist: clean docs
	$(PYTHON) setup.py sdist

rpmcommon: $(MANPAGES) sdist
	@mkdir -p rpm-build
	@cp dist/*.gz rpm-build/
	@sed -e 's#^Version:.*#Version: $(VERSION)#' -e 's#^Release:.*#Release: $(RPMRELEASE)%{?dist}#' $(RPMSPEC) >rpm-build/$(NAME).spec

mock-srpm: /etc/mock/$(MOCK_CFG).cfg rpmcommon
	$(MOCK_BIN) -r $(MOCK_CFG) --resultdir rpm-build/  --buildsrpm --spec rpm-build/$(NAME).spec --sources rpm-build/
	@echo "#############################################"
	@echo "Ansible SRPM is built:"
	@echo rpm-build/*.src.rpm
	@echo "#############################################"

mock-rpm: /etc/mock/$(MOCK_CFG).cfg mock-srpm
	$(MOCK_BIN) -r $(MOCK_CFG) --resultdir rpm-build/ --rebuild rpm-build/$(NAME)-*.src.rpm
	@echo "#############################################"
	@echo "Ansible RPM is built:"
	@echo rpm-build/*.noarch.rpm
	@echo "#############################################"

srpm: rpmcommon
	@rpmbuild --define "_topdir %(pwd)/rpm-build" \
	--define "_builddir %{_topdir}" \
	--define "_rpmdir %{_topdir}" \
	--define "_srcrpmdir %{_topdir}" \
	--define "_specdir $(RPMSPECDIR)" \
	--define "_sourcedir %{_topdir}" \
	-bs rpm-build/$(NAME).spec
	@rm -f rpm-build/$(NAME).spec
	@echo "#############################################"
	@echo "Ansible SRPM is built:"
	@echo "    rpm-build/$(RPMNVR).src.rpm"
	@echo "#############################################"

rpm: rpmcommon
	@rpmbuild --define "_topdir %(pwd)/rpm-build" \
	--define "_builddir %{_topdir}" \
	--define "_rpmdir %{_topdir}" \
	--define "_srcrpmdir %{_topdir}" \
	--define "_specdir $(RPMSPECDIR)" \
	--define "_sourcedir %{_topdir}" \
	--define "_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}.%%{ARCH}.rpm" \
	--define "__python `which $(PYTHON)`" \
	-ba rpm-build/$(NAME).spec
	@rm -f rpm-build/$(NAME).spec
	@echo "#############################################"
	@echo "Ansible RPM is built:"
	@echo "    rpm-build/$(RPMNVR).noarch.rpm"
	@echo "#############################################"

debian: sdist
	@for DIST in $(DEB_DIST) ; do \
	    mkdir -p deb-build/$${DIST} ; \
	    tar -C deb-build/$${DIST} -xvf dist/$(NAME)-$(VERSION).tar.gz ; \
	    cp -a packaging/debian deb-build/$${DIST}/$(NAME)-$(VERSION)/ ; \
        sed -ie "s|%VERSION%|$(VERSION)|g;s|%RELEASE%|$(DEB_RELEASE)|;s|%DIST%|$${DIST}|g;s|%DATE%|$(DEB_DATE)|g" deb-build/$${DIST}/$(NAME)-$(VERSION)/debian/changelog ; \
	done

deb: debian
	@for DIST in $(DEB_DIST) ; do \
	    (cd deb-build/$${DIST}/$(NAME)-$(VERSION)/ && $(DEBUILD) -b) ; \
	done
	@echo "#############################################"
	@echo "Ansible DEB artifacts:"
	@for DIST in $(DEB_DIST) ; do \
	    echo deb-build/$${DIST}/$(NAME)_$(VERSION)-$(DEB_RELEASE)~$${DIST}_amd64.changes ; \
	done
	@echo "#############################################"

deb-src: debian
	@for DIST in $(DEB_DIST) ; do \
	    (cd deb-build/$${DIST}/$(NAME)-$(VERSION)/ && $(DEBUILD) -S) ; \
	done
	@echo "#############################################"
	@echo "Ansible DEB artifacts:"
	@for DIST in $(DEB_DIST) ; do \
	    echo deb-build/$${DIST}/$(NAME)_$(VERSION)-$(DEB_RELEASE)~$${DIST}_source.changes ; \
	done
	@echo "#############################################"

deb-upload: deb
	@for DIST in $(DEB_DIST) ; do \
	    $(DPUT_BIN) $(DPUT_OPTS) $(DEB_PPA) deb-build/$${DIST}/$(NAME)_$(VERSION)-$(DEB_RELEASE)~$${DIST}_amd64.changes ; \
	done

deb-src-upload: deb-src
	@for DIST in $(DEB_DIST) ; do \
	    $(DPUT_BIN) $(DPUT_OPTS) $(DEB_PPA) deb-build/$${DIST}/$(NAME)_$(VERSION)-$(DEB_RELEASE)~$${DIST}_source.changes ; \
	done

# for arch or gentoo, read instructions in the appropriate 'packaging' subdirectory directory

webdocs: $(MANPAGES)
	(cd docsite/; make docs)

docs: $(MANPAGES)

=== packaging/port/sysutils/ansible/Makefile ===
# $FreeBSD$

PORTNAME=	ansible
PORTVERSION=	2.0
PORTREVISION=	1
CATEGORIES=	python net-mgmt sysutils
MASTER_SITES=	http://releases.ansible.com/ansible/
DISTNAME=	${PORTNAME}-${PORTVERSION}

MAINTAINER=	bcoca@ansible.com
COMMENT=	Ansible ssh based config management framework

LICENSE=	GPLv3
LICENSE_FILE=	${WRKSRC}/COPYING

RUN_DEPENDS=	python>2.5:${PORTSDIR}/lang/python \
               ${PORTSDIR}/devel/py-Jinja2 \
               ${PORTSDIR}/devel/py-yaml \
               ${PORTSDIR}/security/py-paramiko \
               ${PORTSDIR}/devel/py-simplejson \
               ${PORTSDIR}/security/py-pycrypto

OPTIONS_DEFINE=	EXAMPLES

FETCH_ARGS=	-pRr

USE_PYTHON=	yes
USE_PYDISTUTILS=	yes

CPE_VENDOR=	Ansible Inc

SUB_FILES=	pkg-message

PLIST_FILES+=	man/man1/ansible-doc.1.gz \
                man/man1/ansible-galaxy.1.gz \
                man/man1/ansible-playbook.1.gz \
                man/man1/ansible-pull.1.gz \
                man/man1/ansible-vault.1.gz \
                man/man1/ansible.1.gz

PORTEXAMPLES=	ansible.cfg hosts

post-patch:
.for f in bin/ansible-galaxy docs/man/man1/ansible-galaxy.1 \
        docs/man/man1/ansible-playbook.1 docs/man/man1/ansible.1 \
        examples/ansible.cfg examples/hosts lib/ansible/constants.py \
        lib/ansible/module_utils/urls.py lib/ansible/modules/core/system/setup.py \
        lib/ansible/playbook/__init__.py lib/ansible/runner/__init__.py
        @${REINPLACE_CMD} -e 's|/etc/ansible|${ETCDIR}|' ${WRKSRC}/${f}
.endfor

.for f in docs/man/man1/ansible-playbook.1 docs/man/man1/ansible.1 \
        examples/ansible.cfg lib/ansible/constants.py \
        lib/ansible/playbook/__init__.py lib/ansible/runner/__init__.py \
        @${REINPLACE_CMD} -e 's|/usr/share/ansible|${DATADIR}|' ${WRKSRC}/${f}
.endfor

post-install:
				@${MKDIR} ${STAGEDIR}${MAN1PREFIX}/man/man1
				${INSTALL_MAN} ${WRKSRC}/docs/man/man1/*.1 \
            ${STAGEDIR}${MAN1PREFIX}/man/man1
				@${MKDIR} ${STAGEDIR}${EXAMPLESDIR}
				${INSTALL_DATA} ${WRKSRC}/examples/ansible.cfg ${STAGEDIR}${EXAMPLESDIR}
				${INSTALL_DATA} ${WRKSRC}/examples/hosts ${STAGEDIR}${EXAMPLESDIR}

.include <bsd.port.mk>

=== debian/changelog ===
ansible (2.0.0.2-2) unstable; urgency=medium

  * Migrate to unstable.
  * Switch Vcs-git to https.

 -- Harlan Lieberman-Berg <hlieberman@setec.io>  Mon, 08 Feb 2016 07:15:41 -0500

ansible (2.0.0.2-1) experimental; urgency=medium

  * New upstream version.

 -- Harlan Lieberman-Berg <hlieberman@setec.io>  Fri, 15 Jan 2016 20:15:26 -0500

ansible (2.0.0.1-1) experimental; urgency=medium

  * New upstream version.
  * Fix up d/control's spacing, ordering.
  * Extensive update of d/copyright with cme.

 -- Harlan Lieberman-Berg <hlieberman@setec.io>  Tue, 12 Jan 2016 22:56:34 -0500

=== debian/control ===
Source: ansible
Maintainer: Janos Guljas <janos@debian.org>
Uploaders: Michael Vogt <mvo@debian.org>,
           Harlan Lieberman-Berg <hlieberman@setec.io>
Section: admin
Priority: optional
Build-Depends: debhelper (>= 9),
               python-all,
               python-crypto,
               python-setuptools,
               python-yaml,
               asciidoc,
               python-nose,
               python-passlib,
               dh-python
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
Vcs-Git: https://anonscm.debian.org/collab-maint/ansible.git
Homepage: http://ansible.com

Package: ansible
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
         python-crypto,
         python-yaml,
         openssh-client | python-paramiko,
         python-jinja2,
         python-httplib2,
         python-netaddr
Recommends: python-selinux
Suggests: sshpass
Description: Configuration management, deployment, and task execution system
 Ansible is a radically simple model-driven configuration management,
 multi-node deployment, and remote task execution system. Ansible works
 over SSH and does not require any software or daemons to be installed
 on remote nodes. Extension modules can be written in any language and
 are transferred to managed machines automatically.

Package: ansible-fireball
Architecture: all
Depends: ${misc:Depends},
         ansible,
         python-keyczar,
         python-zmq
Description: Ansible fireball transport support
 Ansible is a radically simple model-driven configuration management,
 multi-node deployment, and remote task execution system. Ansible works
 over SSH and does not require any software or daemons to be installed
 on remote nodes. Extension modules can be written in any language and
 are transferred to managed machines automatically.
 .
 Ansible can optionally use a 0MQ based transport mechanism, which is
 considerably faster than the standard ssh mechanism when there are
 multiple actions, but requires additional supporting packages.
 .
 This package is a dependency package, which depends on ansible and Python
 modules for keyczar and ZeroMQ.

Package: ansible-node-fireball
Architecture: all
Depends: ${misc:Depends},
         python-keyczar,
         python-zmq
Description: Ansible fireball transport support for nodes
 Ansible is a radically simple model-driven configuration management,
 multi-node deployment, and remote task execution system. Ansible works
 over SSH and does not require any software or daemons to be installed
 on remote nodes. Extension modules can be written in any language and
 are transferred to managed machines automatically.
 .
 Ansible can optionally use a 0MQ based transport mechanism, which has
 additional requirements for nodes to use. This package includes those
 requirements.
 .
 This package is a dependency package, which depends on Python modules for
 keyczar and ZeroMQ.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
https://releases.ansible.com/ansible/ ansible-([0-9\.]+).tar.gz

## ansible 2.0.1.0

=== debian/changelog ===
ansible (2.0.1.0-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Harlan Lieberman-Berg <hlieberman@setec.io>  Sun, 06 Mar 2016 18:15:58 -0500

ansible (2.0.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Fix Vcs-git URI.
  * Bump standards version.

 -- Harlan Lieberman-Berg <hlieberman@setec.io>  Thu, 25 Feb 2016 23:03:33 -0500

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,9 @@
                python-nose,
                python-passlib,
                dh-python
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
-Vcs-Git: https://anonscm.debian.org/collab-maint/ansible.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/ansible.git
 Homepage: http://ansible.com
 
 Package: ansible

## ansible 2.0.2.0

=== debian/changelog ===
ansible (2.0.2.0-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Tue, 10 May 2016 21:39:51 -0400

ansible (2.0.2.0-1) unstable; urgency=medium

  * New upstream release
  * Remove patches applied upstream
  * Change maintainer from Janos to me

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Tue, 19 Apr 2016 22:31:25 -0400

ansible (2.0.1.0-2) unstable; urgency=medium

  * Backport patches to fix vulns in lxc plugin (Closes: #819676)
  * Update my email address

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 10 Apr 2016 18:37:37 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: ansible
-Maintainer: Janos Guljas <janos@debian.org>
+Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
 Uploaders: Michael Vogt <mvo@debian.org>,
-           Harlan Lieberman-Berg <hlieberman@setec.io>
+           Janos Guljas <janos@debian.org>
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9),

## ansible 2.1.0.0

=== debian/changelog ===
ansible (2.1.0.0-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 17 Jul 2016 20:21:18 -0400

ansible (2.1.0.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #826927, #814371)
  * Update d/copyright; add cme hinting files.
  * Bump S-V; no changes required
  * Add manpage for ansible-console.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 12 Jun 2016 21:12:05 -0400

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                python-nose,
                python-passlib,
                dh-python
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/ansible.git
 Homepage: http://ansible.com

## ansible 2.1.1.0

=== Makefile ===
--- 
+++ 
@@ -167,6 +167,9 @@
 sdist: clean docs
 	$(PYTHON) setup.py sdist
 
+sdist_upload: clean docs
+	$(PYTHON) setup.py sdist upload 2>&1 |tee upload.log
+
 rpmcommon: $(MANPAGES) sdist
 	@mkdir -p rpm-build
 	@cp dist/*.gz rpm-build/

=== debian/changelog ===
ansible (2.1.1.0-1~ubuntu16.04.1) xenial-backports; urgency=medium

  * No-change backport to xenial (LP: #1621514)

 -- Felix Geyer <debfx@ubuntu.com>  Sun, 30 Oct 2016 10:44:32 +0100

ansible (2.1.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Update cme copyright helper files.
  * Drop ansible-*fireball, as it is no longer supported.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 31 Jul 2016 22:02:59 -0400

=== debian/control ===
Source: ansible
Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
Uploaders: Michael Vogt <mvo@debian.org>,
           Janos Guljas <janos@debian.org>
Section: admin
Priority: optional
Build-Depends: debhelper (>= 9),
               python-all,
               python-crypto,
               python-setuptools,
               python-yaml,
               asciidoc,
               python-nose,
               python-passlib,
               dh-python
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/ansible.git
Homepage: http://ansible.com

Package: ansible
Architecture: all
Depends: ${misc:Depends},
         ${python:Depends},
         python-crypto,
         python-yaml,
         openssh-client | python-paramiko,
         python-jinja2,
         python-httplib2,
         python-netaddr
Recommends: python-selinux
Suggests: sshpass
Description: Configuration management, deployment, and task execution system
 Ansible is a radically simple model-driven configuration management,
 multi-node deployment, and remote task execution system. Ansible works
 over SSH and does not require any software or daemons to be installed
 on remote nodes. Extension modules can be written in any language and
 are transferred to managed machines automatically.

## ansible 2.2.0.0

=== Makefile ===
--- 
+++ 
@@ -24,8 +24,8 @@
 # directory of the target file ($@), kinda like `dirname`.
 MANPAGES := docs/man/man1/ansible.1 docs/man/man1/ansible-playbook.1 docs/man/man1/ansible-pull.1 docs/man/man1/ansible-doc.1 docs/man/man1/ansible-galaxy.1 docs/man/man1/ansible-vault.1
 ifneq ($(shell which a2x 2>/dev/null),)
-ASCII2MAN = a2x -D $(dir $@) -d manpage -f manpage $<
-ASCII2HTMLMAN = a2x -D docs/html/man/ -d manpage -f xhtml
+ASCII2MAN = a2x -L -D $(dir $@) -d manpage -f manpage $<
+ASCII2HTMLMAN = a2x -L -D docs/html/man/ -d manpage -f xhtml
 else
 ASCII2MAN = @echo "ERROR: AsciiDoc 'a2x' command is not installed but is required to build $(MANPAGES)" && exit 1
 endif
@@ -67,7 +67,7 @@
         DEBUILD_OPTS += -k$(DEBSIGN_KEYID)
     endif
 else
-    DEB_RELEASE = 0.git$(DATE)$(GITINFO)
+    DEB_RELEASE = 100.git$(DATE)$(GITINFO)
     # Do not sign unofficial builds
     DEBUILD_OPTS += -uc -us
     DPUT_OPTS += -u
@@ -83,7 +83,7 @@
 RPMDIST = $(shell rpm --eval '%{?dist}')
 RPMRELEASE = $(RELEASE)
 ifneq ($(OFFICIAL),yes)
-    RPMRELEASE = 0.git$(DATE)$(GITINFO)
+    RPMRELEASE = 100.git$(DATE)$(GITINFO)
 endif
 RPMNVR = "$(NAME)-$(VERSION)-$(RPMRELEASE)$(RPMDIST)"
 
@@ -93,17 +93,20 @@
 
 NOSETESTS ?= nosetests
 
-NOSETESTS3 ?= nosetests-3.4
+NOSETESTS3 ?= nosetests-3.5
 
 ########################################################
 
 all: clean python
 
 tests:
-	PYTHONPATH=./lib $(NOSETESTS) -d -w test/units -v --with-coverage --cover-package=ansible --cover-branches
+	PYTHONPATH=./lib $(NOSETESTS) -d -w test/units -v --with-coverage --cover-package=ansible --cover-branches --cover-erase
 
 tests-py3:
-	PYTHONPATH=./lib $(NOSETESTS3) -d -w test/units -v --with-coverage --cover-package=ansible --cover-branches
+	PYTHONPATH=./lib $(NOSETESTS3) -d -w test/units -v --with-coverage --cover-package=ansible --cover-branches --cover-erase
+
+integration:
+	test/utils/shippable/integration.sh
 
 authors:
 	sh hacking/authors.sh
@@ -261,7 +264,9 @@
 
 # for arch or gentoo, read instructions in the appropriate 'packaging' subdirectory directory
 
-webdocs: $(MANPAGES)
+webdocs:
 	(cd docsite/; make docs)
 
 docs: $(MANPAGES)
+
+alldocs: docs webdocs

=== debian/changelog ===
ansible (2.2.0.0-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Mon, 02 Jan 2017 15:28:38 -0500

ansible (2.2.0.0-1) unstable; urgency=medium

  * New upstream release: (Closes: #843763)
    - CVE-2016-8628 (Closes: #842985)
    - CVE-2016-8614 (Closes: #842984)
  * Add python-kerberos, python-winrm, python-xmltodict to Recommends, needed
    to manage Windows hosts. (Closes: #843995)
  * Suggest cowsay (Closes: #834056)

 -- Lee Garrett <debian@rocketjump.eu>  Fri, 25 Nov 2016 20:52:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: ansible
 Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
-Uploaders: Michael Vogt <mvo@debian.org>,
-           Janos Guljas <janos@debian.org>
+Uploaders: Michael Vogt <mvo@debian.org>
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9),
@@ -16,7 +15,7 @@
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/ansible.git
-Homepage: http://ansible.com
+Homepage: https://www.ansible.com
 
 Package: ansible
 Architecture: all
@@ -28,8 +27,11 @@
          python-jinja2,
          python-httplib2,
          python-netaddr
-Recommends: python-selinux
-Suggests: sshpass
+Recommends: python-kerberos,
+            python-selinux,
+            python-winrm (>= 0.1.1),
+            python-xmltodict
+Suggests: cowsay, sshpass
 Description: Configuration management, deployment, and task execution system
  Ansible is a radically simple model-driven configuration management,
  multi-node deployment, and remote task execution system. Ansible works

## ansible 2.2.1.0

=== Makefile ===
--- 
+++ 
@@ -47,7 +47,7 @@
 GITINFO = ""
 endif
 
-ifeq ($(shell echo $(OS) | egrep -c 'Darwin|FreeBSD|OpenBSD'),1)
+ifeq ($(shell echo $(OS) | egrep -c 'Darwin|FreeBSD|OpenBSD|DragonFly'),1)
 DATE := $(shell date -j -r $(shell git log -n 1 --format="%at") +%Y%m%d%H%M)
 else
 DATE := $(shell date --utc --date="$(GIT_DATE)" +%Y%m%d%H%M)
@@ -76,6 +76,12 @@
 DEB_PPA ?= ppa
 # Choose the desired Ubuntu release: lucid precise saucy trusty
 DEB_DIST ?= unstable
+
+# pbuilder parameters
+PBUILDER_ARCH ?= amd64
+PBUILDER_CACHE_DIR = /var/cache/pbuilder
+PBUILDER_BIN ?= pbuilder
+PBUILDER_OPTS ?= --debootstrapopts --variant=buildd --architecture $(PBUILDER_ARCH) --debbuildopts -b
 
 # RPM build parameters
 RPMSPECDIR= packaging/rpm
@@ -230,7 +236,23 @@
         sed -ie "s|%VERSION%|$(VERSION)|g;s|%RELEASE%|$(DEB_RELEASE)|;s|%DIST%|$${DIST}|g;s|%DATE%|$(DEB_DATE)|g" deb-build/$${DIST}/$(NAME)-$(VERSION)/debian/changelog ; \
 	done
 
-deb: debian
+deb: deb-src
+	@for DIST in $(DEB_DIST) ; do \
+	    PBUILDER_OPTS="$(PBUILDER_OPTS) --distribution $${DIST} --basetgz $(PBUILDER_CACHE_DIR)/$${DIST}-$(PBUILDER_ARCH)-base.tgz --buildresult $(CURDIR)/deb-build/$${DIST}" ; \
+	    $(PBUILDER_BIN) create $${PBUILDER_OPTS} --othermirror "deb http://archive.ubuntu.com/ubuntu $${DIST} universe" ; \
+	    $(PBUILDER_BIN) update $${PBUILDER_OPTS} ; \
+	    $(PBUILDER_BIN) build $${PBUILDER_OPTS} deb-build/$${DIST}/$(NAME)_$(VERSION)-$(DEB_RELEASE)~$${DIST}.dsc ; \
+	done
+	@echo "#############################################"
+	@echo "Ansible DEB artifacts:"
+	@for DIST in $(DEB_DIST) ; do \
+	    echo deb-build/$${DIST}/$(NAME)_$(VERSION)-$(DEB_RELEASE)~$${DIST}_amd64.changes ; \
+	done
+	@echo "#############################################"
+
+# Build package outside of pbuilder, with locally installed dependencies.
+# Install BuildRequires as noted in packaging/debian/control.
+local_deb: debian
 	@for DIST in $(DEB_DIST) ; do \
 	    (cd deb-build/$${DIST}/$(NAME)-$(VERSION)/ && $(DEBUILD) -b) ; \
 	done

=== debian/changelog ===
ansible (2.2.1.0-2+deb9u3) stretch-security; urgency=medium

  * Fix CVE-2019-10206:
    ansible-playbook -k and ansible cli tools, all versions 2.8.x before 2.8.4,
    all 2.7.x before 2.7.13 and all 2.6.x before 2.6.19, prompt passwords by
    expanding them from templates as they could contain special characters.
    Passwords should be wrapped to prevent templates trigger and exposing them.
  * Fix CVE-2019-14856:
    This fixes a regression introduced by the fix of CVE-2019-10206.
  * Fix CVE-2020-10684:
    A flaw was found in Ansible Engine, all versions 2.7.x, 2.8.x and 2.9.x
    prior to 2.7.17, 2.8.9 and 2.9.6 respectively, when using ansible_facts as
    a subkey of itself and promoting it to a variable when inject is enabled,
    overwriting the ansible_facts after the clean. An attacker could take
    advantage of this by altering the ansible_facts, such as ansible_hosts,
    users and any other key data which would lead into privilege escalation 
    or code injection.

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 03 Feb 2022 18:34:23 +0100

ansible (2.2.1.0-2+deb9u2) stretch-security; urgency=high

  * Non-maintainer upload by the LTS team.
  * Fix CVE-2017-7481:
    Ansible fails to properly mark lookup-plugin results as unsafe. If an
    attacker could control the results of lookup() calls, they could inject
    Unicode strings to be parsed by the jinja2 templating system, resulting in
    code execution. By default, the jinja2 templating language is now marked as
    'unsafe' and is not evaluated.
  * Fix CVE-2019-10156:
    A flaw was discovered in the way Ansible templating was implemented,
    causing the possibility of information disclosure through unexpected
    variable substitution. By taking advantage of unintended variable
    substitution the content of any variable may be disclosed.
  * Fix CVE-2019-14846:
    Ansible was logging at the DEBUG level which lead to a disclosure of
    credentials if a plugin used a library that logged credentials at the DEBUG
    level. This flaw does not affect Ansible modules, as those are executed in
    a separate process.
  * Fix CVE-2019-14904:
    A flaw was found in the solaris_zone module from the Ansible Community
    modules. When setting the name for the zone on the Solaris host, the zone
    name is checked by listing the process with the 'ps' bare command on the
    remote machine. An attacker could take advantage of this flaw by crafting
    the name of the zone and executing arbitrary commands in the remote host.

 -- Markus Koschany <apo@debian.org>  Wed, 27 Jan 2021 16:24:29 +0100

ansible (2.2.1.0-2+deb9u1) stretch-security; urgency=high

  * Add patch to fix CVE 2018-10855.
  * Add patch to fix CVE 2018-16837.
  * Add patch to fix CVE 2018-10875.
  * Add patch to fix CVE 2018-16876.
  * Add patch to fix CVE 2019-3828.

 -- Lee Garrett <debian@rocketjump.eu>  Mon, 11 Feb 2019 00:11:51 +0100

ansible (2.2.1.0-2) unstable; urgency=medium

  * Add patch to fix CVE-2017-7466.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Wed, 12 Apr 2017 00:56:30 -0400

ansible (2.2.1.0-1) unstable; urgency=medium

  * New upstream release
  * Remove following patches, applied upstream:
    - fix_CVE-2016-8647.patch
    - fix_pip_venv.patch
    - fix_UnboundedLocalError.patch
    - fix-cve-2016-9587.patch
  * Add myself to uploaders.

 -- Lee Garrett <debian@rocketjump.eu>  Sat, 21 Jan 2017 21:27:15 +0100

ansible (2.2.0.0-4) unstable; urgency=high

  * Commit to git the changelog line I actually used.
  * Cherry-pick patch fixing git module error. (Closes: #850935)
  * Cherry-pick patch fixing python3 + virtualenv problems. (Closes: #847546)
  * Cherry-pick patch fixing CVE-2016-8647 (Closes: #844691)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sat, 14 Jan 2017 15:30:48 -0500

ansible (2.2.0.0-3) unstable; urgency=high

  * Apply additional fixes for CVE-2016-9587 (Closes: #850846)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Fri, 13 Jan 2017 21:17:56 -0500

ansible (2.2.0.0-2) unstable; urgency=high

  * Cherry-pick patch to fix CVE-2016-9587 (Closes: #850846)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Tue, 10 Jan 2017 20:14:07 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: ansible
-Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
-Uploaders: Michael Vogt <mvo@debian.org>
+Maintainer: Lee Garrett <debian@rocketjump.eu>
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9),

## ansible 2.3.1.0+dfsg

=== debian/changelog ===
ansible (2.3.1.0+dfsg-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Fri, 01 Sep 2017 17:18:19 -0400

ansible (2.3.1.0+dfsg-2) unstable; urgency=high

  * Import patch fixing jinja2 issues (Closes: #870599, #871601)
  * Revert python-jinja2 pin.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 27 Aug 2017 19:57:43 -0400

ansible (2.3.1.0+dfsg-1) unstable; urgency=high

  [ Lee Garrett ]
  * The "Harlan is late for DebCamp" release.
  * New upstream release (Closes: #845613, 851619, #868553)
    - fixed CVE-2017-7481 (Closes: #862666)
  * Add python-libcloud to recommends (Closes: #869751)
  * Add python-jmespath to recommends (Closes: #859999)
  * Bump Standards-Version to 4.0.0 (no changes needed)
  * Add python-cryptography to recommends to speed up vault operations.
  * Drop 0001-add-console-manpage.patch and 0002-fix-cve-2017-7466.patch,
    both applied upstream.

  [ Harlan Lieberman-Berg ]
  * Pin python-jinja2 against incompatible new releases.
  * Import patch fixing htpasswd module. (Closes: #863949)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Mon, 07 Aug 2017 17:26:53 -0400

## ansible 2.4.0.0+dfsg

=== debian/changelog ===
ansible (2.4.0.0+dfsg-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports. (Closes: #880596)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Thu, 02 Nov 2017 19:00:55 -0400

ansible (2.4.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove 0002-fix-jinja-1.9-upgrade.patch, applied upstream.

 -- Lee Garrett <debian@rocketjump.eu>  Wed, 20 Sep 2017 00:52:02 +0200

ansible (2.3.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove 01-fix-htpasswd.patch, applied upstream.
  * Upstream fixes:
    - Fix --force for unversioned requirements (Closes: #874194)
    - attempt to fix systemd in chroot env (Closes: 873890)

 -- Lee Garrett <debian@rocketjump.eu>  Sun, 10 Sep 2017 21:20:43 -0400

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: ansible
-Maintainer: Lee Garrett <debian@rocketjump.eu>
+Maintainer: Harlan Lieberman-Berg <hlieberman@debian.org>
+Uploaders: Michael Vogt <mvo@debian.org>, Lee Garrett <debian@rocketjump.eu>
 Section: admin
 Priority: optional
 Build-Depends: debhelper (>= 9),
@@ -11,7 +12,7 @@
                python-nose,
                python-passlib,
                dh-python
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/ansible.git
 Homepage: https://www.ansible.com
@@ -26,7 +27,10 @@
          python-jinja2,
          python-httplib2,
          python-netaddr
-Recommends: python-kerberos,
+Recommends: python-cryptography,
+            python-jmespath,
+            python-kerberos,
+            python-libcloud,
             python-selinux,
             python-winrm (>= 0.1.1),
             python-xmltodict

## ansible 2.4.3.0+dfsg

=== debian/changelog ===
ansible (2.4.3.0+dfsg-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sat, 10 Feb 2018 16:32:03 -0500

ansible (2.4.3.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 01 Feb 2018 13:45:09 +0100

ansible (2.4.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.1 (no changes needed)
  * Add new manpages for ansible-config and ansible-inventory, added in 2.4.0.

 -- Lee Garrett <debian@rocketjump.eu>  Wed, 06 Dec 2017 20:48:46 +0100

## ansible 2.5.1+dfsg

=== Makefile ===
# WARN: gmake syntax
########################################################
# Makefile for Ansible
#
# useful targets:
#   make sdist ---------------- produce a tarball
#   make srpm ----------------- produce a SRPM
#   make rpm  ----------------- produce RPMs
#   make deb-src -------------- produce a DEB source
#   make deb ------------------ produce a DEB
#   make docs ----------------- rebuild the manpages (results are checked in)
#   make tests ---------------- run the tests (see https://docs.ansible.com/ansible/dev_guide/testing_units.html for requirements)
#   make pyflakes, make pep8 -- source code checks

########################################################
# variable section

NAME = ansible
OS = $(shell uname -s)
PREFIX ?= '/usr/local'

# This doesn't evaluate until it's called. The -D argument is the
# directory of the target file ($@), kinda like `dirname`.
MANPAGES ?= $(patsubst %.asciidoc.in,%,$(wildcard ./docs/man/man1/ansible*.1.asciidoc.in))
ifneq ($(shell which a2x 2>/dev/null),)
ASCII2MAN = a2x -L -D $(dir $@) -d manpage -f manpage $<
ASCII2HTMLMAN = a2x -L -D docs/html/man/ -d manpage -f xhtml
else
ASCII2MAN = @echo "ERROR: AsciiDoc 'a2x' command is not installed but is required to build $(MANPAGES)" && exit 1
endif
GENERATE_CLI = docs/bin/generate_man.py

PYTHON=python
SITELIB = $(shell $(PYTHON) -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")

# fetch version from project release.py as single source-of-truth
VERSION := $(shell $(PYTHON) packaging/release/versionhelper/version_helper.py --raw || echo error)
ifeq ($(findstring error,$(VERSION)), error)
$(error "version_helper failed")
endif
# if a specific release was not requested, set to 0 (RPMs have "fancier" logic for this further down)
RELEASE ?= 1

# Get the branch information from git
ifneq ($(shell which git),)
GIT_DATE := $(shell git log -n 1 --format="%ai")
GIT_HASH := $(shell git log -n 1 --format="%h")
GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD | sed 's/[-_.\/]//g')
GITINFO = .$(GIT_HASH).$(GIT_BRANCH)
else
GITINFO = ""
endif

ifeq ($(shell echo $(OS) | egrep -c 'Darwin|FreeBSD|OpenBSD|DragonFly'),1)
DATE := $(shell date -j -r $(shell git log -n 1 --format="%at") +%Y%m%d%H%M)
CPUS ?= $(shell sysctl hw.ncpu|awk '{print $$2}')
else
DATE := $(shell date --utc --date="$(GIT_DATE)" +%Y%m%d%H%M)
CPUS ?= $(shell nproc)
endif

# DEB build parameters
DEBUILD_BIN ?= debuild
DEBUILD_OPTS = --source-option="-I"
DPUT_BIN ?= dput
DPUT_OPTS ?=
DEB_DATE := $(shell LC_TIME=C date +"%a, %d %b %Y %T %z")
DEB_VERSION := $(shell $(PYTHON) packaging/release/versionhelper/version_helper.py --debversion)
ifeq ($(OFFICIAL),yes)
    DEB_RELEASE := $(shell $(PYTHON) packaging/release/versionhelper/version_helper.py --debrelease)ppa
    # Sign OFFICIAL builds using 'DEBSIGN_KEYID'
    # DEBSIGN_KEYID is required when signing
    ifneq ($(DEBSIGN_KEYID),)
        DEBUILD_OPTS += -k$(DEBSIGN_KEYID)
    endif
else
    DEB_RELEASE = 100.git$(DATE)$(GITINFO)
    # Do not sign unofficial builds
    DEBUILD_OPTS += -uc -us
    DPUT_OPTS += -u
endif
DEBUILD = $(DEBUILD_BIN) $(DEBUILD_OPTS)
DEB_PPA ?= ppa
# Choose the desired Ubuntu release: lucid precise saucy trusty
DEB_DIST ?= unstable

# pbuilder parameters
PBUILDER_ARCH ?= amd64
PBUILDER_CACHE_DIR = /var/cache/pbuilder
PBUILDER_BIN ?= pbuilder
PBUILDER_OPTS ?= --debootstrapopts --variant=buildd --architecture $(PBUILDER_ARCH) --debbuildopts -b

# RPM build parameters
RPMSPECDIR= packaging/rpm
RPMSPEC = $(RPMSPECDIR)/ansible.spec
RPMDIST = $(shell rpm --eval '%{?dist}')

ifneq ($(OFFICIAL),yes)
    RPMRELEASE = 100.git$(DATE)$(GITINFO)
endif
ifeq ($(PUBLISH),nightly)
    # https://fedoraproject.org/wiki/Packaging:Versioning#Snapshots
    RPMRELEASE = $(RELEASE).$(DATE)git.$(GIT_HASH)
endif

RPMVERSION ?= $(shell $(PYTHON) packaging/release/versionhelper/version_helper.py --baseversion)
RPMRELEASE ?= $(shell $(PYTHON) packaging/release/versionhelper/version_helper.py --rpmrelease)
RPMNVR = "$(NAME)-$(RPMVERSION)-$(RPMRELEASE)$(RPMDIST)$(REPOTAG)"

# MOCK build parameters
MOCK_BIN ?= mock
MOCK_CFG ?=

# dynamically add repotag define only if specified
ifneq ($(REPOTAG),)
    EXTRA_RPM_DEFINES += --define "repotag $(REPOTAG)"
endif

# ansible-test parameters
ANSIBLE_TEST ?= test/runner/ansible-test
TEST_FLAGS ?=

# ansible-test units parameters (make test / make test-py3)
PYTHON_VERSION ?= $(shell python2 -c 'import sys; print("%s.%s" % sys.version_info[:2])')
PYTHON3_VERSION ?= $(shell python3 -c 'import sys; print("%s.%s" % sys.version_info[:2])')

# ansible-test integration parameters (make integration)
IMAGE ?= centos7
TARGET ?=

########################################################

.PHONY: all
all: clean python

.PHONY: tests
tests:
	$(ANSIBLE_TEST) units -v --python $(PYTHON_VERSION) $(TEST_FLAGS)

.PHONY: tests-py3
tests-py3:
	$(ANSIBLE_TEST) units -v --python $(PYTHON3_VERSION) $(TEST_FLAGS)

.PHONY: tests-nonet
tests-nonet:
	$(ANSIBLE_TEST) units -v --python $(PYTHON_VERSION) $(TEST_FLAGS)  --exclude test/units/modules/network/

.PHONY: integration
integration:
	$(ANSIBLE_TEST) integration -v --docker $(IMAGE) $(TARGET) $(TEST_FLAGS)

.PHONY: authors
authors:
	sh hacking/authors.sh

# Regenerate %.1.asciidoc if %.1.asciidoc.in has been modified more
# recently than %.1.asciidoc.
%.1.asciidoc: %.1.asciidoc.in
	sed "s/%VERSION%/$(VERSION)/" $< > $@

# Regenerate %.1 if %.1.asciidoc or release.py has been modified more
# recently than %.1. (Implicitly runs the %.1.asciidoc recipe)
%.1: %.1.asciidoc lib/ansible/release.py
	$(ASCII2MAN)

.PHONY: loc
loc:
	sloccount lib library bin

.PHONY: pep8
pep8:
	$(ANSIBLE_TEST) sanity --test pep8 --python $(PYTHON_VERSION) $(TEST_FLAGS)

.PHONY: pyflakes
pyflakes:
	pyflakes lib/ansible/*.py lib/ansible/*/*.py bin/*

.PHONY: clean
clean:
	@echo "Cleaning up distutils stuff"
	rm -rf build
	rm -rf dist
	rm -rf lib/ansible.egg-info/
	@echo "Cleaning up byte compiled python stuff"
	find . -type f -regex ".*\.py[co]$$" -delete
	find . -type d -name "__pycache__" -delete
	@echo "Cleaning up editor backup files"
	find . -type f -not -path ./test/units/inventory_test_data/group_vars/noparse/all.yml~ \( -name "*~" -or -name "#*" \) -delete
	find . -type f \( -name "*.swp" \) -delete
	@echo "Cleaning up manpage stuff"
	find ./docs/man -type f -name "*.xml" -delete
	find ./docs/man -type f -name "*.asciidoc" -delete
	find ./docs/man/man3 -type f -name "*.3" -delete
	rm -f ./docs/man/man1/*
	@echo "Cleaning up output from test runs"
	rm -rf test/test_data
	rm -rf shippable/
	rm -rf logs/
	rm -rf .cache/
	rm -f test/units/.coverage*
	rm -rf test/results/*/*
	find test/ -type f -name '*.retry' -delete
	@echo "Cleaning up RPM building stuff"
	rm -rf MANIFEST rpm-build
	@echo "Cleaning up Debian building stuff"
	rm -rf debian
	rm -rf deb-build
	rm -rf docs/json
	rm -rf docs/js
	@echo "Cleaning up authors file"
	rm -f AUTHORS.TXT
	@echo "Cleaning up docsite"
	$(MAKE) -C docs/docsite clean
	$(MAKE) -C docs/api clean

.PHONY: python
python:
	$(PYTHON) setup.py build

.PHONY: install
install:
	$(PYTHON) setup.py install

install_manpages:
	gzip -9 $(wildcard ./docs/man/man1/ansible*.1)
	cp $(wildcard ./docs/man/man1/ansible*.1.gz) $(PREFIX)/man/man1/

.PHONY: sdist
sdist: clean docs changelog_aggregate
	$(PYTHON) setup.py sdist

.PHONY: sdist_upload
sdist_upload: clean docs
	$(PYTHON) setup.py sdist upload 2>&1 |tee upload.log

# TODO: variable-ize major version number usages here
.PHONY: changelog_reno
changelog_reno:
	reno -d changelogs/ report --title 'Ansible 2.5 "Kashmir" Release Notes' --collapse-pre-release --no-show-source --earliest-version v2.5.0b1 --output changelogs/CHANGELOG-v2.5.rst

.PHONY: changelog_aggregate
changelog_aggregate:
	echo "TODO: unified changelog" > changelogs/CHANGELOG.rst

.PHONY: rpmcommon
rpmcommon: sdist
	@mkdir -p rpm-build
	@cp dist/*.gz rpm-build/
	@cp $(RPMSPEC) rpm-build/$(NAME).spec

.PHONY: mock-srpm
mock-srpm: /etc/mock/$(MOCK_CFG).cfg rpmcommon
	$(MOCK_BIN) -r $(MOCK_CFG) $(MOCK_ARGS) --resultdir rpm-build/ --bootstrap-chroot --old-chroot --buildsrpm --spec rpm-build/$(NAME).spec --sources rpm-build/ \
    --define "rpmversion $(RPMVERSION)" \
	--define "upstream_version $(VERSION)" \
	--define "rpmrelease $(RPMRELEASE)" \
	$(EXTRA_RPM_DEFINES)
	@echo "#############################################"
	@echo "Ansible SRPM is built:"
	@echo rpm-build/*.src.rpm
	@echo "#############################################"

.PHONY: mock-rpm
mock-rpm: /etc/mock/$(MOCK_CFG).cfg mock-srpm
	$(MOCK_BIN) -r $(MOCK_CFG) $(MOCK_ARGS) --resultdir rpm-build/ --bootstrap-chroot --old-chroot --rebuild rpm-build/$(NAME)-*.src.rpm \
    --define "rpmversion $(RPMVERSION)" \
	--define "upstream_version $(VERSION)" \
	--define "rpmrelease $(RPMRELEASE)" \
	$(EXTRA_RPM_DEFINES)
	@echo "#############################################"
	@echo "Ansible RPM is built:"
	@echo rpm-build/*.noarch.rpm
	@echo "#############################################"

.PHONY: srpm
srpm: rpmcommon
	@rpmbuild --define "_topdir %(pwd)/rpm-build" \
	--define "_builddir %{_topdir}" \
	--define "_rpmdir %{_topdir}" \
	--define "_srcrpmdir %{_topdir}" \
	--define "_specdir $(RPMSPECDIR)" \
	--define "_sourcedir %{_topdir}" \
	--define "upstream_version $(VERSION)" \
	--define "rpmversion $(RPMVERSION)" \
	--define "rpmrelease $(RPMRELEASE)" \
	$(EXTRA_RPM_DEFINES) \
	-bs rpm-build/$(NAME).spec
	@rm -f rpm-build/$(NAME).spec
	@echo "#############################################"
	@echo "Ansible SRPM is built:"
	@echo "    rpm-build/$(RPMNVR).src.rpm"
	@echo "#############################################"

.PHONY: rpm
rpm: rpmcommon
	@rpmbuild --define "_topdir %(pwd)/rpm-build" \
	--define "_builddir %{_topdir}" \
	--define "_rpmdir %{_topdir}" \
	--define "_srcrpmdir %{_topdir}" \
	--define "_specdir $(RPMSPECDIR)" \
	--define "_sourcedir %{_topdir}" \
	--define "_rpmfilename $(RPMNVR).%%{ARCH}.rpm" \
	--define "__python `which $(PYTHON)`" \
	--define "upstream_version $(VERSION)" \
	--define "rpmversion $(RPMVERSION)" \
	--define "rpmrelease $(RPMRELEASE)" \
	$(EXTRA_RPM_DEFINES) \
	-ba rpm-build/$(NAME).spec
	@rm -f rpm-build/$(NAME).spec
	@echo "#############################################"
	@echo "Ansible RPM is built:"
	@echo "    rpm-build/$(RPMNVR).noarch.rpm"
	@echo "#############################################"

.PHONY: debian
debian: sdist
	@for DIST in $(DEB_DIST) ; do \
	    mkdir -p deb-build/$${DIST} ; \
	    tar -C deb-build/$${DIST} -xvf dist/$(NAME)-$(VERSION).tar.gz ; \
	    cp -a packaging/debian deb-build/$${DIST}/$(NAME)-$(VERSION)/ ; \
        sed -ie "s|%VERSION%|$(DEB_VERSION)|g;s|%RELEASE%|$(DEB_RELEASE)|;s|%DIST%|$${DIST}|g;s|%DATE%|$(DEB_DATE)|g" deb-build/$${DIST}/$(NAME)-$(VERSION)/debian/changelog ; \
	done

.PHONY: deb
deb: deb-src
	@for DIST in $(DEB_DIST) ; do \
	    PBUILDER_OPTS="$(PBUILDER_OPTS) --distribution $${DIST} --basetgz $(PBUILDER_CACHE_DIR)/$${DIST}-$(PBUILDER_ARCH)-base.tgz --buildresult $(CURDIR)/deb-build/$${DIST}" ; \
	    $(PBUILDER_BIN) create $${PBUILDER_OPTS} --othermirror "deb http://archive.ubuntu.com/ubuntu $${DIST} universe" ; \
	    $(PBUILDER_BIN) update $${PBUILDER_OPTS} ; \
	    $(PBUILDER_BIN) build $${PBUILDER_OPTS} deb-build/$${DIST}/$(NAME)_$(DEB_VERSION)-$(DEB_RELEASE)~$${DIST}.dsc ; \
	done
	@echo "#############################################"
	@echo "Ansible DEB artifacts:"
	@for DIST in $(DEB_DIST) ; do \
	    echo deb-build/$${DIST}/$(NAME)_$(DEB_VERSION)-$(DEB_RELEASE)~$${DIST}_amd64.changes ; \
	done
	@echo "#############################################"

# Build package outside of pbuilder, with locally installed dependencies.
# Install BuildRequires as noted in packaging/debian/control.
.PHONY: local_deb
local_deb: debian
	@for DIST in $(DEB_DIST) ; do \
	    (cd deb-build/$${DIST}/$(NAME)-$(VERSION)/ && $(DEBUILD) -b) ; \
	done
	@echo "#############################################"
	@echo "Ansible DEB artifacts:"

=== packaging/port/sysutils/ansible/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # $FreeBSD$
 
 PORTNAME=	ansible
-PORTVERSION=	2.0
+PORTVERSION=	2.1
 PORTREVISION=	1
 CATEGORIES=	python net-mgmt sysutils
 MASTER_SITES=	http://releases.ansible.com/ansible/

=== test/utils/docker/cloudstack-simulator/Makefile ===
build:
	docker build -t cloudstack-sim .

clean:
	docker rm -f cloudstack

run:
	docker run --name cloudstack -d -p 8080:8080 -p 8888:8888 cloudstack-sim

shell:
	docker exec -it cloudstack /bin/bash

logs:
	docker logs -f  cloudstack

=== debian/changelog ===
ansible (2.5.1+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 19 Apr 2018 11:22:34 +0200

ansible (2.5.0+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Lee Garrett <debian@rocketjump.eu>  Sun, 25 Mar 2018 14:39:53 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python-nose,
                python-passlib,
                dh-python
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/ansible.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/ansible.git
 Homepage: https://www.ansible.com

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2 -Spython_distutils

## ansible 2.5.2+dfsg

=== debian/changelog ===
ansible (2.5.2+dfsg-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Tue, 08 May 2018 19:44:41 -0400

ansible (2.5.2+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Lee Garrett <debian@rocketjump.eu>  Sat, 28 Apr 2018 17:39:10 +0200
